/* EGA output for S5230
* 20.09.2014 ver 1.0
***********************/

#ifndef _EGA_OUT
#define _EGA_OUT

#include "LCD_API.c"
#define EGA_EN  1
#define EGA_DIS 0

#define BLACK     0
#define BLUE      1
#define GREEN     2
#define SKY	      3
#define RED       4
#define MAGENTA   5
#define YELLOW    6
#define GREY      7
#define LBLUE     9
#define LGREEN   10
#define LSKY     11
#define LRED     12
#define LMAGENTA 13
#define LYELLOW  14
#define WHITE    15

u8 EGAbuf[16][50][2];		//buffer dlia vivoda
u8 EGA = 0,WINtop[2] = {0,0},WINbot[2] = {15,49},cursor[2] = {0,0};//stndart razmer okna vivoda i cursora
void init_EGA(void)
{
	u8 i,k;
	for (i=0;i<16;i++)
	{
		for (k=0;k<50;k++) 
		{
			EGAbuf[i][k][0] = 0;
			EGAbuf[i][k][1] = 0x07;
		};
	};
};

void EGA_cls(void)
{
	u8 i,k;
	if (WINtop[0] > 14) WINtop[0] = 14;				//proverka predelov fizicheskogo okna i terminala
	if (WINbot[0] > 15) WINbot[0] = 15;				//tipa ASSERT
	if (WINtop[1] > 49) WINtop[1] = 49;
	if (WINbot[1] > 49) WINbot[1] = 49;
	if (cursor[0] > WINbot[0]) cursor[0] = WINbot[0];
	if (cursor[0] < WINtop[0]) cursor[0] = WINtop[0];
	if (cursor[1] > WINbot[1]) cursor[1] = WINbot[1];
	if (cursor[1] < WINtop[1]) cursor[1] = WINtop[1];
	for (i=WINtop[0];i<=WINbot[0];i++)			// ochistka
	{
		for (k=WINtop[1];k<=WINbot[1];k++) 
		{
			EGAbuf[i][k][0] = 0;
			EGAbuf[i][k][1] = 0x07;
		};
	};
	EGAbuf[WINtop[0]][WINtop[1]][1] = 0x87;		//ustanovka cursora
	cursor[0] = WINtop[0],cursor[1] = WINtop[1];
}

void EGA_scroll(void)
{	
	u8 i,k;
	if (WINbot[0]>WINtop[0])
	{
		for (i=WINtop[0]+1;i<=WINbot[0];i++)
		{
			for (k=WINtop[1];k<=WINbot[1];k++)
			{
				EGAbuf[i-1][k][0] = EGAbuf[i][k][0];
				EGAbuf[i-1][k][1] = EGAbuf[i][k][1];
			};
		};
		for (k=WINtop[1];k<=WINbot[1];k++)
			{
				EGAbuf[WINbot[0]][k][0] = 0;
				EGAbuf[WINbot[0]][k][1] = 0x07;
			};
	};
};
void WINout(void)		//vivod okonnoi chasti bufera
{						//mozhno v prerivanie ili prosto vizivat, togda ne budet morgat cursor
	u8 i,k;
	u16 tmp,tcolor,bcolor;
	for (i=WINtop[0];i<=WINbot[0];i++)
		{
			for (k=WINtop[1];k<=WINbot[1];k++)
			{
				tcolor = 0;			//formiruiu 16bit cvet znaka iz 4bit 
				tmp = EGAbuf[i][k][1] & 0x04;
				if (tmp) tcolor |=((tmp) | (EGAbuf[i][k][1] & 0x08))<<12; 
				tmp = EGAbuf[i][k][1] & 0x02;
				if (tmp) tcolor |=((tmp<<1) | (EGAbuf[i][k][1] & 0x08))<<7; 
				tmp = EGAbuf[i][k][1] & 0x01;
				if (tmp) tcolor |=((tmp<<2) | (EGAbuf[i][k][1] & 0x08))<<1; 
				bcolor = 0;			////formiruiu 16bit cvet fona iz 3bit 
				tmp = EGAbuf[i][k][1] & 0x40,bcolor |= tmp<<8;
				tmp = EGAbuf[i][k][1] & 0x20,bcolor |= tmp<<4;
				tmp = EGAbuf[i][k][1] & 0x10,bcolor |= tmp>>1;
				put_char(k*CHAR_W,i*CHAR_H+28,EGAbuf[i][k][0],tcolor,bcolor);  //pechat znaka(zavisit ot tipa displeia)
				if ((EGAbuf[i][k][1] & 0x80) && DT.Seconds%2) 					//pechat cursora, migaet 1 raz v 2 secundy
					 {drawLine(k*CHAR_W+7,i*CHAR_H+27,k*CHAR_W+7,i*CHAR_H+14,tcolor);} //cursor - vert cherta |
				else {drawLine(k*CHAR_W+7,i*CHAR_H+27,k*CHAR_W+7,i*CHAR_H+14,bcolor);};
			};
		};
};

void PRINT_chr(char c,int color,int bgcolor)
{
	EGAbuf[cursor[0]][cursor[1]][0] = c;		//pechat simvola v bufer
	EGAbuf[cursor[0]][cursor[1]][1] = (color & 0x0F) | ((bgcolor & 0x07)<<4); //perevod cursora
	cursor[1]++;
	if (cursor[1] > WINbot[1]) {cursor[1] = WINtop[1],cursor[0]++;};
	if (cursor[0] > WINbot[0]) {EGA_scroll(),cursor[0] = WINbot[0];};
	EGAbuf[cursor[0]][cursor[1]][1] |= 0x80;
};

void PRINT_string(char *str,int color,int bgcolor)
{
  unsigned char  j=0,fl=0;
  while (j<strlen(str))
   {
   if (str[j] != '\n') PRINT_chr(str[j],color,bgcolor);
	   else {
	EGAbuf[cursor[0]][cursor[1]][1] &=~ 0x80;	//perevod cursora na novuiu stroku po simvolu \n
	cursor[1] = WINtop[1];
	cursor[0]++;
	if (cursor[0] > WINbot[0]) {EGA_scroll(),cursor[0] = WINbot[0];};
	EGAbuf[cursor[0]][cursor[1]][1] |= 0x80;
	   };
   j++;
   }
};

#endif